// Digital Affirmation Mirror (simple) by Becky Stern - beckystern.com
// based on the demo sketch for the quad alphanumeric display LED backpack library fron Adafruit
// requires the following libraries, search in Library Manager or download from github:

#include <Wire.h>                  // installed by default
#include <SPI.h>
#include <Adafruit_GFX.h>          // https://github.com/adafruit/Adafruit-GFX-Library
#include <Adafruit_LEDBackpack.h>  // https://github.com/adafruit/Adafruit_LED_Backpack

// affirmations go here
String message0 = "'FAILURE IS ALWAYS AN OPTION' -ADAM SAVAGE            ";
String message1 = "'POWER IS NOT GIVEN TO YOU - YOU HAVE TO TAKE IT' -BEYONCE KNOWLES-CARTER            ";
String message2 = "'I DON'T MEASURE MYSELF BY OTHERS' EXPECTATIONS OR LET OTHERS DEFINE MY WORTH' -SONIA SOTOMAYOR            ";
String message3 = "'WE MUST ACCEPT FINITE DISAPPOINTMENT, BUT NEVER LOSE INFINITE HOPE' -MARTIN LUTHER KING JR            ";
String message4 = "'NOW IS THE TIME TO UNDERSTAND MORE SO THAT WE MAY FEAR LESS' -MARIE CURIE            ";
String message5 = "'DON'T COMPROMISE YOURSELF - YOU'RE ALL YOU'VE GOT' -JANIS JOPLIN            ";
String message6 = "'IF YOU HAVE GOOD THOUGHTS THEY WILL SHINE OUT YOUR FACE LIKE SUNBEAMS AND YOU WILL ALWAYS LOOK LOVELY' -ROALD DAHL            ";
String message7 = "'WHAT MAKES YOU DIFFERENT OR WEIRD - THAT'S YOUR STRENGTH' -MERYL STREEP            ";
String message8 = "'WHO YOU ARE INSIDE IS WHAT HELPS YOU MAKE AND DO EVERYTHING IN LIFE' -FRED ROGERS            ";
String message9 = "'I'M NOT AFRAID OF STORMS FOR I'M LEARNING TO SAIL MY SHIP' -LOUISA MAY ALCOTT            ";
String message10 = "'I AM DELIBERATE AND AFRAID OF NOTHING' -AUDRE LORD            ";
String message11 = "'WHAT WE DWELL ON IS WHAT WE BECOME' -OPRAH WINFREY            ";
String message12 = "'ALWAYS BE A FIRST-RATE VERSION OF YOURSELF INSTEAD OF A SECOND-RATE VERSION OF SOMEBODY ELSE' -JUDY GARLAND            ";
String message13 = "'AM I GOOD ENOUGH? YES I AM' -MICHELLE OBAMA            ";
String message14 = "'YOU HAVE TO BELIEVE IN YOURSELF OR NO ONE ELSE WILL' -SARAH MICHELLE GELLER            ";
String message15 = "NOTHING CAN DIM THE LIGHT THAT SHINES FROM WITHIN' -MAYA ANGELOU            ";
String message16 = "'MY STRENGTH LIES SOLELY IN MY TENACITY' -LOUIS PASTEUR            ";

String messages[] = {message0, message1, message2, message3, message4, message5, message6, message7, message8, message9, message10, message11, message12, message13, message14, message15, message16};

struct { // label the alphanumeric displays with their i2c addresses
  uint8_t           addr;         // I2C address
  Adafruit_AlphaNum4 alpha4;         // 7segment object
} disp[] = {
  { 0x70, Adafruit_AlphaNum4() },  // left-hand display
  { 0x72, Adafruit_AlphaNum4() },  // middle display
  { 0x71, Adafruit_AlphaNum4() },  // right-hand display

};

void setup() {
  //Serial.begin(115200);
  
  for(uint8_t i=0; i<3; i++) {       // Initialize 3 displays
    disp[i].alpha4.begin(disp[i].addr);
    disp[i].alpha4.clear();
    disp[i].alpha4.writeDisplay();
  }
}

char displaybuffer[12] = {' ', ' ', ' ', ' ',' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '};

void loop() {

String displayRandomMessage = messages[random(16)];
Serial.println(displayRandomMessage);

for (int i=0; i<displayRandomMessage.length(); i++){
  
  // scroll down display
  displaybuffer[0] = displaybuffer[1];
  displaybuffer[1] = displaybuffer[2];
  displaybuffer[2] = displaybuffer[3];
  displaybuffer[3] = displaybuffer[4];
  displaybuffer[4] = displaybuffer[5];
  displaybuffer[5] = displaybuffer[6];
  displaybuffer[6] = displaybuffer[7];
  displaybuffer[7] = displaybuffer[8];
  displaybuffer[8] = displaybuffer[9];
  displaybuffer[9] = displaybuffer[10];
  displaybuffer[10] = displaybuffer[11];
  displaybuffer[11] = displayRandomMessage.charAt(i);

  // set every digit to the buffer
  disp[0].alpha4.writeDigitAscii(0, displaybuffer[0]);
  disp[0].alpha4.writeDigitAscii(1, displaybuffer[1]);
  disp[0].alpha4.writeDigitAscii(2, displaybuffer[2]);
  disp[0].alpha4.writeDigitAscii(3, displaybuffer[3]);
  disp[1].alpha4.writeDigitAscii(0, displaybuffer[4]);
  disp[1].alpha4.writeDigitAscii(1, displaybuffer[5]);
  disp[1].alpha4.writeDigitAscii(2, displaybuffer[6]);
  disp[1].alpha4.writeDigitAscii(3, displaybuffer[7]);
  disp[2].alpha4.writeDigitAscii(0, displaybuffer[8]);
  disp[2].alpha4.writeDigitAscii(1, displaybuffer[9]);
  disp[2].alpha4.writeDigitAscii(2, displaybuffer[10]);
  disp[2].alpha4.writeDigitAscii(3, displaybuffer[11]);
 
  // write it out!
  disp[0].alpha4.writeDisplay();
  disp[1].alpha4.writeDisplay();
  disp[2].alpha4.writeDisplay();
  delay(150);
  }
}
